% readpgm --  reads an RGB image file in PPM RAW format.

function [image,width,height] = readppm(filename)

   if (nargin < 1) 
      error('Too few input arguments.');
   elseif (isstr(filename)) 
      fid = fopen(filename,'r');
      if (fid < 0) error(['Can not open file: ',filename]); end
   elseif (filename>=0 & filename<256)
      fid = floor(filename);
   else
      error('Argument must be a string or file ID.'); 
   end;

   idline = fgetl(fid);
   if (~isstr(idline)) 
      error(['File is empty: ',filename]); 
   elseif (idline(1) ~= 'P') 
      error(['Not a PNM file: ',filename]); 
   elseif (idline(2) ~= '6' & idline(2) ~= '3')
      error(['PNM but not PPM file: ',filename]); 
   end

   whline = fgetl(fid);
   if length(whline) == 0, whline(1) = '#'; end
   while whline(1) == '#', 
      whline = fgetl(fid);
      if length(whline) == 0, whline(1) = '#'; end
   end
   [vek, count] = sscanf(whline,' %d',2);
   width = vek(1);
   height = vek(2);

   whline = fgetl(fid);
   if length(whline) == 0, whline(1) = '#'; end
   while whline(1) == '#', 
      whline = fgetl(fid);
      if length(whline) == 0, whline(1) = '#'; end
   end
   [range, count] = sscanf(whline,' %d',1);
   
   if (idline(2) == '6')
      [image,count] = fread(fid,[3*width,height],'uchar') ;
   elseif (idline(2) == '3')
      [image,count] = fscanf(fid,' %d ',[3*width,height]);
   end
   if (isstr(filename)) fclose(fid); end;
%end;
